## sarg 2.2.6

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
PROJECT(sarg C)
SET(sarg_VERSION 2)
SET(sarg_REVISION 2)
SET(sarg_BUILD "6")
SET(sarg_BUILDDATE "Nov-30-2009")

INCLUDE(AddFileDependencies)
INCLUDE(CheckIncludeFile)
INCLUDE(CheckLibraryExists)
INCLUDE(CheckFunctionExists)
INCLUDE(CheckTypeSize)
INCLUDE(CheckSymbolExists)

DEFINE_PROPERTY(GLOBAL PROPERTY enable-htmldir BRIEF_DOCS "--enable-htmldir=htmldir"
                        FULL_DOCS "Select htmldir as the root of your WWW documents")

SET(PACKAGE_NAME "sarg")
SET(PACKAGE_VERSION "${sarg_VERSION}.${sarg_REVISION}.${sarg_BUILD}")

MACRO(SET_ABS_SOURCE VAR DOC)
   IF(${VAR} AND NOT ${VAR}_SOURCE)
      SET(PATH "${${VAR}}")
      IF(NOT IS_ABSOLUTE ${PATH})
         SET(PATH "${CMAKE_INSTALL_PREFIX}/${PATH}")
      ENDIF(NOT IS_ABSOLUTE ${PATH})
      GET_FILENAME_COMPONENT(SOURCE_PATH "${PATH}" ABSOLUTE)
      SET(${VAR}_SOURCE "${SOURCE_PATH}" CACHE PATH "${DOC}")
   ENDIF(${VAR} AND NOT ${VAR}_SOURCE)
ENDMACRO(SET_ABS_SOURCE VAR DOC)

SET_ABS_SOURCE(SYSCONFDIR "The full path of the configuration directory to be compiled in the program")
SET_ABS_SOURCE(LANGDIR "The full path of the language directory to be compiled in the program")
SET_ABS_SOURCE(FONTDIR "The full path of the fonts directory to be compiled in the program")
SET_ABS_SOURCE(IMAGEDIR "The full path of the images directory to be compiled in the program")

SET(SYSCONFDIR "etc/sarg" CACHE PATH "The configuration directory relative to the install directory")
SET(BINDIR "bin" CACHE PATH "The directory to install the exec relative to the install directory")
SET(MANDIR "share/man" CACHE PATH "The directory to copy the man page relative to the install directory")
SET(LANGDIR "share/sarg/languages" CACHE PATH "The directory to copy the languages files relative to the install directory")
SET(FONTDIR "share/sarg/fonts" CACHE PATH "The directory to copy the fonts relative to the install directory")
SET(IMAGEDIR "share/sarg/images" CACHE PATH "The directory to copy the images files relative to the install directory")

# Sources to compile
INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}") #Make it find this config.h before the one in src/include
INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/include")
SET(SRC util.c log.c report.c topuser.c email.c sort.c html.c
       totger.c index.c getconf.c usage.c decomp.c ip2name.c
       useragent.c exclude.c convlog.c totday.c repday.c datafile.c
       indexonly.c splitlog.c lastlog.c topsites.c siteuser.c css.c
       smartfilter.c denied.c authfail.c language.c charset.c
       squidguard_log.c squidguard_report.c auth.c download.c grepday.c
       dansguardian_log.c dansguardian_report.c realtime.c)

FOREACH(f ${SRC})
   ADD_FILE_DEPENDENCIES(${f} ${CMAKE_BINARY_DIR}/config.h ${CMAKE_SOURCE_DIR}/include/conf.h ${CMAKE_SOURCE_DIR}/include/info.h ${CMAKE_SOURCE_DIR}/include/defs.h)
ENDFOREACH(f)

ADD_EXECUTABLE(sarg ${SRC})

SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAG "${CFLAGS} -Wall -Wextra -Werror=implicit-function-declaration -Werror=format")
SET_TARGET_PROPERTIES(sarg PROPERTIES VERSION "${sarg_VERSION}.${sarg_REVISION}.${sarg_BUILD}")

# Required header files
CHECK_INCLUDE_FILE(stdio.h HAVE_STDIO_H)
CHECK_INCLUDE_FILE(stdlib.h HAVE_STDLIB_H)
CHECK_INCLUDE_FILE(string.h HAVE_STRING_H)
CHECK_INCLUDE_FILE(strings.h HAVE_STRINGS_H)
CHECK_INCLUDE_FILE(sys/time.h HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILE(time.h HAVE_TIME_H)
CHECK_INCLUDE_FILE(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILE(sys/dirent.h HAVE_SYS_DIRENT_H)
CHECK_INCLUDE_FILE(dirent.h HAVE_DIRENT_H)
CHECK_INCLUDE_FILE(sys/socket.h HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILE(netdb.h HAVE_NETDB_H)
CHECK_INCLUDE_FILE(arpa/inet.h HAVE_ARPA_INET_H)
CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE(netinet/in.h HAVE_NETINET_H)
CHECK_INCLUDE_FILE(sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE(ctype.h HAVE_CTYPE_H)
CHECK_INCLUDE_FILE(errno.h HAVE_ERRNO_H)
CHECK_INCLUDE_FILE(sys/resource.h HAVE_SYS_RESOURCE_H)
CHECK_INCLUDE_FILE(sys/wait.h HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILE(stdarg.h HAVE_STDARG_H)
CHECK_INCLUDE_FILE(inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE(limits.h HAVE_LIMITS_H)

CHECK_FUNCTION_EXISTS(bzero HAVE_BZERO)

# Find gd
CHECK_INCLUDE_FILE(gd.h HAVE_GD_H)
IF(HAVE_GD_H)
   CHECK_INCLUDE_FILE(gdfontl.h HAVE_GDFONTL_H)
   CHECK_INCLUDE_FILE(gdfontt.h HAVE_GDFONTT_H)
   CHECK_INCLUDE_FILE(gdfonts.h HAVE_GDFONTS_H)
   CHECK_INCLUDE_FILE(gdfontmb.h HAVE_GDFONTMB_H)
   CHECK_INCLUDE_FILE(gdfontg.h HAVE_GDFONTG_H)
   FIND_LIBRARY(GD_LIBRARY NAMES gd DOC "The GD library")
   IF(GD_LIBRARY)
      #CHECK_LIBRARY_EXISTS(gd gdImagePng "." HAVE_GD)
      TARGET_LINK_LIBRARIES(sarg gd)
      SET(HAVE_GD GD_LIBRARY CACHE PATH DOC "True IF GD was found")
      SET(HAVE_GD CACHE BOOL DOC "True IF must use GD")
   ENDIF(GD_LIBRARY)
ENDIF(HAVE_GD_H)

# Find iconv
OPTION(ENABLE_ICONV "Enable the usage of iconv" ON)
IF(ENABLE_ICONV)
   CHECK_INCLUDE_FILE(iconv.h HAVE_ICONV_H)
   IF(HAVE_ICONV_H)
      CHECK_FUNCTION_EXISTS(iconv_open HAVE_ICONV)
      IF(!HAVE_ICONV)
         FIND_PATH(ICONV_INCLUDE_PATH NAMES iconv.h)
         FIND_LIBRARY(ICONV_LIBRARY NAMES iconv DOC "The ICONV library")
      ENDIF(!HAVE_ICONV)

      SET(ICONV_CONST_FILE ${CMAKE_BINARY_DIR}/consticonv.c)
      FILE(WRITE ${ICONV_CONST_FILE} "
#include <stdlib.h>
#include <iconv.h>
extern
#ifdef __cplusplus
"C"
#endif
#if defined(__STDC__) || defined(__cplusplus)
size_t iconv (iconv_t cd, char * *inbuf, size_t *inbytesleft, char * *outbuf, size_t *outbytesleft);
#else
size_t iconv();
#endif
")
      TRY_COMPILE(USE_CONST_ICONV ${CMAKE_BINARY_DIR} ${ICONV_CONST_FILE})
      FILE(REMOVE ${ICONV_CONST_FILE})
      IF(USE_CONST_ICONV)
         SET(ICONV_CONST "\"const\"")
      ENDIF(USE_CONST_ICONV)
   ENDIF(HAVE_ICONV_H)
ENDIF(ENABLE_ICONV)

# Support for large files
OPTION(ENABLE_LARGEFILE "Enable the usage of large files" ON)
IF(ENABLE_LARGEFILE)
   IF(LFS_SEARCHED MATCHES "^LFS_SEARCHED$")
      SET(SEARCH_LARGEFILE TRUE)
   ENDIF(LFS_SEARCHED MATCHES "^LFS_SEARCHED$")
ENDIF(ENABLE_LARGEFILE)

IF(SEARCH_LARGEFILE)
   SET(LFS_SEARCHED TRUE CACHE INTERNAL "LFS has been searched")
   MESSAGE(STATUS "Looking for large file support")
   SET(LFS_FILE "${CMAKE_BINARY_DIR}/lfsfopen64.c")
   FILE(WRITE ${LFS_FILE} "
#include <stdio.h>
int main(void)
{
FILE *f = fopen64 (\"/tmp/foo\",\"r\");
return(0);
}
")
   TRY_COMPILE(HAVE_FOPEN64 ${CMAKE_BINARY_DIR} ${LFS_FILE} COMPILE_DEFINITIONS "-Wall -Werror")
   IF(HAVE_FOPEN64)
      MESSAGE(STATUS "Looking for large file support - found")
   ELSE(HAVE_FOPEN64)
      SET(LFS_NEED_DEFINE FALSE CACHE BOOL "Does LFS require _LARGEFILE64_SOURCE ?")
      MESSAGE(STATUS "Looking for large file support with _LARGEFILE64_SOURCE")
      FILE(WRITE ${LFS_FILE} "
#define _LARGEFILE64_SOURCE
#include <stdio.h>
int main(void)
{
FILE *f = fopen64 (\"/tmp/foo\",\"r\");
return(0);
}
")
      TRY_COMPILE(HAVE_FOPEN64 ${CMAKE_BINARY_DIR} ${LFS_FILE} OUTPUT_VARIABLE LFS_OUTPUT)
      IF(HAVE_FOPEN64)
         MESSAGE(STATUS "Looking for large file support with _LARGEFILE64_SOURCE - found")
         SET(LFS_NEED_DEFINE TRUE CACHE BOOL "Does LFS require _LARGEFILE64_SOURCE ?" FORCE)
      ELSE(HAVE_FOPEN64)
         MESSAGE("Failed with output ${LFS_OUTPUT}")
      ENDIF(HAVE_FOPEN64)
   ENDIF(HAVE_FOPEN64)
   FILE(REMOVE ${LFS_FILE})
ENDIF(SEARCH_LARGEFILE)

IF(LFS_NEED_DEFINE)
   ADD_DEFINITIONS(-D_LARGEFILE64_SOURCE)
ENDIF(LFS_NEED_DEFINE)

# Find off_t size
CHECK_TYPE_SIZE(off_t OFF_T)
IF(HAVE_OFF_T)
   IF(OFF_T STREQUAL 4)
      SET(OFFSET_STRING "\"%d\"")
   elseif(OFF_T STREQUAL 8)
      SET(OFFSET_STRING "\"%\"PRId64")
   ENDIF(OFF_T STREQUAL 4)
ELSE(HAVE_OFF_T)
   MESSAGE(FATAL_ERROR Need off_t to compile the program)
ENDIF(HAVE_OFF_T)

# Find rlim_t
IF(HAVE_SYS_RESOURCE_H)
   SET(CMAKE_EXTRA_INCLUDE_FILES "sys/resource.h")
ENDIF(HAVE_SYS_RESOURCE_H)
CHECK_TYPE_SIZE(rlim_t RLIM_T)
IF(HAVE_RLIM_T)
   IF(RLIM_T STREQUAL 4)
      SET(RLIM_STRING "%d")
   ELSEIF(RLIM_T STREQUAL 8)
      SET(RLIM_STRING "%lli")
   ELSE(RLIM_T STREQUAL 4)
      MESSAGE("Unknown rlim_t size")
   ENDIF(RLIM_T STREQUAL 4)
ELSE(HAVE_RLIM_T)
   MESSAGE("Cannot detect the size of your system's rlim_t type")
ENDIF(HAVE_RLIM_T)

# Windows need lib wsock32
IF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
   CHECK_INCLUDE_FILE(windows.h HAVE_WINDOWS_H)
   CHECK_INCLUDE_FILE(winsock.h HAVE_WINSOCK_H)
   FIND_LIBRARY(WSOCK_LIB NAMES wsock32 DOC "The winsock library")
   #check_library_exists(wsock32 "." HAVE_WSOCK)
   IF(WSOCK_LIB)
      #set_target_properties(sarg PROPERTIES LINK_FLAGS "${LINK_FLAGS} -lwsock32")
      TARGET_LINK_LIBRARIES(sarg wsock32)
   ENDIF(WSOCK_LIB)
   ADD_DEFINITIONS(-DWINDOWS)
ENDIF(CMAKE_SYSTEM_NAME STREQUAL "Windows")

CHECK_FUNCTION_EXISTS(mkstemp HAVE_MKSTEMP)
IF(NOT HAVE_MKSTEMP)
   # MingW provide mkstemps in libiberty but doesn't declare it in any header file
   FIND_LIBRARY(IBERTY_LIB NAMES iberty DOC "The library of mingw containing mkstemps")
   IF(IBERTY_LIB)
      TARGET_LINK_LIBRARIES(sarg iberty)
   ENDIF(IBERTY_LIB)
ENDIF(NOT HAVE_MKSTEMP)

# System particularities
IF(CMAKE_SYSTEM_NAME STREQUAL "solaris")
   TARGET_LINK_LIBRARIES(sarg socket nsl)
   #SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_DEFINITIONS="-DSOLARIS ${COMPILE_DEFINITIONS}")
   ADD_DEFINITIONS(-DSOLARIS)
ENDIF(CMAKE_SYSTEM_NAME STREQUAL "solaris")

OPTION(ENABLE_EXTRA_PROTECT "Enable compile and runtime extra protections" OFF)
IF(ENABLE_EXTRA_PROTECT)
   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAG "${CFLAGS} -Werror=format-security -fstack-protector -D_FORTIFY_SOURCE=2 -Werror -Wextra -Wno-sign-compare -Wno-unused-parameter")
ENDIF(ENABLE_EXTRA_PROTECT)

# Save the configuration for the project
CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/config.h.in" "${CMAKE_BINARY_DIR}/config.h" @ONLY)

# Installation of the project
INSTALL(TARGETS sarg DESTINATION "${BINDIR}")
INSTALL(FILES sarg.conf DESTINATION "${SYSCONFDIR}" RENAME sarg.conf.exemple)
INSTALL(FILES exclude_codes user_limit_block css.tpl DESTINATION "${SYSCONFDIR}")
INSTALL(FILES sarg.1 DESTINATION "${MANDIR}")
INSTALL(DIRECTORY languages/ DESTINATION "${LANGDIR}" PATTERN "CVS" EXCLUDE)
INSTALL(DIRECTORY images/ DESTINATION "${IMAGEDIR}" PATTERN "CVS" EXCLUDE)
INSTALL(DIRECTORY fonts/ DESTINATION "${FONTDIR}" FILES_MATCHING PATTERN "*.ttf" PATTERN "CVS" EXCLUDE)

# Package creation
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Squid Analysis Report Generator")
SET(CPACK_PACKAGE_VERSION_MAJOR "${sarg_VERSION}")
SET(CPACK_PACKAGE_VERSION_MINOR "${sarg_REVISION}")
SET(CPACK_PACKAGE_VERSION_PATCH "${sarg_BUILD}")
SET(CPACK_GENERATOR TGZ)
SET(CPACK_SOURCE_GENERATOR TGZ)
SET(CPACK_SOURCE_IGNORE_FILES "/CVS/" "/debian/" "/html/" "Makefile$" "config\\\\.log$" "config\\\\.status$" ".*~$" "\\\\.o$")
INCLUDE(CPack)

## sarg 2.2.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
 SET(sarg_REVISION 2)
-SET(sarg_BUILD "6")
-SET(sarg_BUILDDATE "Nov-30-2009")
+SET(sarg_BUILD "7.1")
+SET(sarg_BUILDDATE "Feb-12-2010")
 
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)
@@ -11,6 +11,7 @@
 INCLUDE(CheckFunctionExists)
 INCLUDE(CheckTypeSize)
 INCLUDE(CheckSymbolExists)
+INCLUDE(CheckCCompilerFlag)
 
 DEFINE_PROPERTY(GLOBAL PROPERTY enable-htmldir BRIEF_DOCS "--enable-htmldir=htmldir"
                         FULL_DOCS "Select htmldir as the root of your WWW documents")
@@ -40,6 +41,7 @@
 SET(LANGDIR "share/sarg/languages" CACHE PATH "The directory to copy the languages files relative to the install directory")
 SET(FONTDIR "share/sarg/fonts" CACHE PATH "The directory to copy the fonts relative to the install directory")
 SET(IMAGEDIR "share/sarg/images" CACHE PATH "The directory to copy the images files relative to the install directory")
+SET(SARGPHPDIR "share/sarg/sarg-php" CACHE PATH "The directory to copy sarg-php relative to the install directory")
 
 # Sources to compile
 INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}") #Make it find this config.h before the one in src/include
@@ -58,8 +60,22 @@
 
 ADD_EXECUTABLE(sarg ${SRC})
 
-SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAG "${CFLAGS} -Wall -Wextra -Werror=implicit-function-declaration -Werror=format")
 SET_TARGET_PROPERTIES(sarg PROPERTIES VERSION "${sarg_VERSION}.${sarg_REVISION}.${sarg_BUILD}")
+
+SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "$ENV{CFLAGS} -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter")
+SET_TARGET_PROPERTIES(sarg PROPERTIES LINK_FLAGS "$ENV{LDFLAGS}")
+
+CHECK_C_COMPILER_FLAG("-Werror=implicit-function-declaration" HAVE_WERROR_IMPLICIT_FUNCTION)
+IF(HAVE_WERROR_IMPLICIT_FUNCTION)
+   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Werror=implicit-function-declaration")
+ENDIF(HAVE_WERROR_IMPLICIT_FUNCTION)
+
+CHECK_C_COMPILER_FLAG("-Werror=format" HAVE_WERROR_FORMAT)
+IF(HAVE_WERROR_FORMAT)
+   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Werror=format")
+ENDIF(HAVE_WERROR_FORMAT)
 
 # Required header files
 CHECK_INCLUDE_FILE(stdio.h HAVE_STDIO_H)
@@ -84,8 +100,13 @@
 CHECK_INCLUDE_FILE(stdarg.h HAVE_STDARG_H)
 CHECK_INCLUDE_FILE(inttypes.h HAVE_INTTYPES_H)
 CHECK_INCLUDE_FILE(limits.h HAVE_LIMITS_H)
+CHECK_INCLUDE_FILE(locale.h HAVE_LOCALE_H)
+CHECK_INCLUDE_FILE(execinfo.h HAVE_EXECINFO_H)
 
 CHECK_FUNCTION_EXISTS(bzero HAVE_BZERO)
+CHECK_FUNCTION_EXISTS(backtrace HAVE_BACKTRACE)
+CHECK_FUNCTION_EXISTS(symlink HAVE_SYMLINK)
+CHECK_FUNCTION_EXISTS(lstat HAVE_LSTAT)
 
 # Find gd
 CHECK_INCLUDE_FILE(gd.h HAVE_GD_H)
@@ -95,10 +116,10 @@
    CHECK_INCLUDE_FILE(gdfonts.h HAVE_GDFONTS_H)
    CHECK_INCLUDE_FILE(gdfontmb.h HAVE_GDFONTMB_H)
    CHECK_INCLUDE_FILE(gdfontg.h HAVE_GDFONTG_H)
-   FIND_LIBRARY(GD_LIBRARY NAMES gd DOC "The GD library")
+   FIND_LIBRARY(GD_LIBRARY NAMES gd bgd DOC "The GD library")
    IF(GD_LIBRARY)
       #CHECK_LIBRARY_EXISTS(gd gdImagePng "." HAVE_GD)
-      TARGET_LINK_LIBRARIES(sarg gd)
+      TARGET_LINK_LIBRARIES(sarg ${GD_LIBRARY})
       SET(HAVE_GD GD_LIBRARY CACHE PATH DOC "True IF GD was found")
       SET(HAVE_GD CACHE BOOL DOC "True IF must use GD")
    ENDIF(GD_LIBRARY)
@@ -109,11 +130,12 @@
 IF(ENABLE_ICONV)
    CHECK_INCLUDE_FILE(iconv.h HAVE_ICONV_H)
    IF(HAVE_ICONV_H)
+      FIND_PATH(ICONV_INCLUDE_PATH NAMES iconv.h)
+      FIND_LIBRARY(ICONV_LIBRARY NAMES iconv DOC "The ICONV library")
+      IF(ICONV_LIBRARY)
+         TARGET_LINK_LIBRARIES(sarg ${ICONV_LIBRARY})
+      ENDIF(ICONV_LIBRARY)
       CHECK_FUNCTION_EXISTS(iconv_open HAVE_ICONV)
-      IF(!HAVE_ICONV)
-         FIND_PATH(ICONV_INCLUDE_PATH NAMES iconv.h)
-         FIND_LIBRARY(ICONV_LIBRARY NAMES iconv DOC "The ICONV library")
-      ENDIF(!HAVE_ICONV)
 
       SET(ICONV_CONST_FILE ${CMAKE_BINARY_DIR}/consticonv.c)
       FILE(WRITE ${ICONV_CONST_FILE} "
@@ -187,18 +209,6 @@
    ADD_DEFINITIONS(-D_LARGEFILE64_SOURCE)
 ENDIF(LFS_NEED_DEFINE)
 
-# Find off_t size
-CHECK_TYPE_SIZE(off_t OFF_T)
-IF(HAVE_OFF_T)
-   IF(OFF_T STREQUAL 4)
-      SET(OFFSET_STRING "\"%d\"")
-   elseif(OFF_T STREQUAL 8)
-      SET(OFFSET_STRING "\"%\"PRId64")
-   ENDIF(OFF_T STREQUAL 4)
-ELSE(HAVE_OFF_T)
-   MESSAGE(FATAL_ERROR Need off_t to compile the program)
-ENDIF(HAVE_OFF_T)
-
 # Find rlim_t
 IF(HAVE_SYS_RESOURCE_H)
    SET(CMAKE_EXTRA_INCLUDE_FILES "sys/resource.h")
@@ -247,7 +257,13 @@
 
 OPTION(ENABLE_EXTRA_PROTECT "Enable compile and runtime extra protections" OFF)
 IF(ENABLE_EXTRA_PROTECT)
-   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAG "${CFLAGS} -Werror=format-security -fstack-protector -D_FORTIFY_SOURCE=2 -Werror -Wextra -Wno-sign-compare -Wno-unused-parameter")
+   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -fstack-protector -D_FORTIFY_SOURCE=2 -Werror")
+   CHECK_C_COMPILER_FLAG("-Wformat -Werror=format-security" HAVE_WERROR_FORMAT_SECURITY)
+   IF(HAVE_WERROR_FORMAT_SECURITY)
+      GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+      SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Wformat -Werror=format-security")
+   ENDIF(HAVE_WERROR_FORMAT_SECURITY)
 ENDIF(ENABLE_EXTRA_PROTECT)
 
 # Save the configuration for the project
@@ -258,9 +274,10 @@
 INSTALL(FILES sarg.conf DESTINATION "${SYSCONFDIR}" RENAME sarg.conf.exemple)
 INSTALL(FILES exclude_codes user_limit_block css.tpl DESTINATION "${SYSCONFDIR}")
 INSTALL(FILES sarg.1 DESTINATION "${MANDIR}")
-INSTALL(DIRECTORY languages/ DESTINATION "${LANGDIR}" PATTERN "CVS" EXCLUDE)
-INSTALL(DIRECTORY images/ DESTINATION "${IMAGEDIR}" PATTERN "CVS" EXCLUDE)
-INSTALL(DIRECTORY fonts/ DESTINATION "${FONTDIR}" FILES_MATCHING PATTERN "*.ttf" PATTERN "CVS" EXCLUDE)
+INSTALL(DIRECTORY languages/ DESTINATION "${LANGDIR}" PATTERN ".svn" EXCLUDE)
+INSTALL(DIRECTORY images/ DESTINATION "${IMAGEDIR}" PATTERN ".svn" EXCLUDE)
+INSTALL(DIRECTORY fonts/ DESTINATION "${FONTDIR}" FILES_MATCHING PATTERN "*.ttf" PATTERN ".svn" EXCLUDE)
+INSTALL(DIRECTORY sarg-php/ DESTINATION "${SARGPHPDIR}" PATTERN ".svn" EXCLUDE)
 
 # Package creation
 SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Squid Analysis Report Generator")
@@ -269,5 +286,5 @@
 SET(CPACK_PACKAGE_VERSION_PATCH "${sarg_BUILD}")
 SET(CPACK_GENERATOR TGZ)
 SET(CPACK_SOURCE_GENERATOR TGZ)
-SET(CPACK_SOURCE_IGNORE_FILES "/CVS/" "/debian/" "/html/" "Makefile$" "config\\\\.log$" "config\\\\.status$" ".*~$" "\\\\.o$")
+SET(CPACK_SOURCE_IGNORE_FILES "/.svn/" "/debian/" "/html/" "Makefile$" "config\\\\.log$" "config\\\\.status$" ".*~$" "\\\\.o$")
 INCLUDE(CPack)

## sarg 2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
-SET(sarg_REVISION 2)
-SET(sarg_BUILD "7.1")
-SET(sarg_BUILDDATE "Feb-12-2010")
+SET(sarg_REVISION "3")
+SET(sarg_BUILD "")
+SET(sarg_BUILDDATE "Jun-21-2010")
 
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)
@@ -17,7 +17,7 @@
                         FULL_DOCS "Select htmldir as the root of your WWW documents")
 
 SET(PACKAGE_NAME "sarg")
-SET(PACKAGE_VERSION "${sarg_VERSION}.${sarg_REVISION}.${sarg_BUILD}")
+SET(PACKAGE_VERSION "${sarg_VERSION}.${sarg_REVISION}${sarg_BUILD}")
 
 MACRO(SET_ABS_SOURCE VAR DOC)
    IF(${VAR} AND NOT ${VAR}_SOURCE)
@@ -50,9 +50,10 @@
        totger.c index.c getconf.c usage.c decomp.c ip2name.c
        useragent.c exclude.c convlog.c totday.c repday.c datafile.c
        indexonly.c splitlog.c lastlog.c topsites.c siteuser.c css.c
-       smartfilter.c denied.c authfail.c language.c charset.c
+       smartfilter.c denied.c authfail.c charset.c
        squidguard_log.c squidguard_report.c auth.c download.c grepday.c
-       dansguardian_log.c dansguardian_report.c realtime.c)
+       dansguardian_log.c dansguardian_report.c realtime.c btree_cache.c
+       usertab.c userinfo.c longline.c)
 
 FOREACH(f ${SRC})
    ADD_FILE_DEPENDENCIES(${f} ${CMAKE_BINARY_DIR}/config.h ${CMAKE_SOURCE_DIR}/include/conf.h ${CMAKE_SOURCE_DIR}/include/info.h ${CMAKE_SOURCE_DIR}/include/defs.h)
@@ -62,8 +63,15 @@
 
 SET_TARGET_PROPERTIES(sarg PROPERTIES VERSION "${sarg_VERSION}.${sarg_REVISION}.${sarg_BUILD}")
 
-SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "$ENV{CFLAGS} -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter")
+SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "$ENV{CFLAGS} -Wall -Wno-sign-compare")
 SET_TARGET_PROPERTIES(sarg PROPERTIES LINK_FLAGS "$ENV{LDFLAGS}")
+
+CHECK_C_COMPILER_FLAG("-Wextra" HAVE_WEXTRA)
+IF(HAVE_WEXTRA)
+   # Not supported by gcc 3.3
+   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
+   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Wextra -Wno-unused-parameter")
+ENDIF(HAVE_WEXTRA)
 
 CHECK_C_COMPILER_FLAG("-Werror=implicit-function-declaration" HAVE_WERROR_IMPLICIT_FUNCTION)
 IF(HAVE_WERROR_IMPLICIT_FUNCTION)
@@ -100,13 +108,45 @@
 CHECK_INCLUDE_FILE(stdarg.h HAVE_STDARG_H)
 CHECK_INCLUDE_FILE(inttypes.h HAVE_INTTYPES_H)
 CHECK_INCLUDE_FILE(limits.h HAVE_LIMITS_H)
+CHECK_INCLUDE_FILE(math.h HAVE_MATH_H)
 CHECK_INCLUDE_FILE(locale.h HAVE_LOCALE_H)
 CHECK_INCLUDE_FILE(execinfo.h HAVE_EXECINFO_H)
+CHECK_INCLUDE_FILE(libintl.h HAVE_LIBINTL_H)
+CHECK_INCLUDE_FILE(libgen.h HAVE_LIBGEN_H)
+CHECK_INCLUDE_FILE(stdbool.h HAVE_STDBOOL_H)
+CHECK_INCLUDE_FILE(getopt.h HAVE_GETOPT_H)
+
+IF(!HAVE_GETOPT_H)
+   MESSAGE(SEND_ERROR "getopt.h is required to compile sarg")
+ENDIF(!HAVE_GETOPT_H)
+
+# Windows need lib wsock32 and ws2_32
+IF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
+   CHECK_INCLUDE_FILE(windows.h HAVE_WINDOWS_H)
+   CHECK_INCLUDE_FILE(winsock.h HAVE_WINSOCK_H)
+   CHECK_INCLUDE_FILE(ws2tcpip.h HAVE_WS2TCPIP_H)
+
+   FIND_LIBRARY(WSOCK_LIB NAMES wsock32 DOC "The winsock library")
+   IF(WSOCK_LIB)
+      TARGET_LINK_LIBRARIES(sarg wsock32)
+      LIST(APPEND CMAKE_REQUIRED_LIBRARIES wsock32)
+   ENDIF(WSOCK_LIB)
+
+   FIND_LIBRARY(WSOCK2_LIB NAMES ws2_32 DOC "The winsock 2 library")
+   IF(WSOCK2_LIB)
+      TARGET_LINK_LIBRARIES(sarg ws2_32)
+      LIST(APPEND CMAKE_REQUIRED_LIBRARIES ws2_32)
+   ENDIF(WSOCK2_LIB)
+
+   ADD_DEFINITIONS(-DWINDOWS)
+ENDIF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
 
 CHECK_FUNCTION_EXISTS(bzero HAVE_BZERO)
 CHECK_FUNCTION_EXISTS(backtrace HAVE_BACKTRACE)
 CHECK_FUNCTION_EXISTS(symlink HAVE_SYMLINK)
 CHECK_FUNCTION_EXISTS(lstat HAVE_LSTAT)
+CHECK_FUNCTION_EXISTS(getnameinfo HAVE_GETNAMEINFO)
+CHECK_FUNCTION_EXISTS(inet_aton HAVE_INET_ATON)
 
 # Find gd
 CHECK_INCLUDE_FILE(gd.h HAVE_GD_H)
@@ -118,10 +158,10 @@
    CHECK_INCLUDE_FILE(gdfontg.h HAVE_GDFONTG_H)
    FIND_LIBRARY(GD_LIBRARY NAMES gd bgd DOC "The GD library")
    IF(GD_LIBRARY)
-      #CHECK_LIBRARY_EXISTS(gd gdImagePng "." HAVE_GD)
+      #CHECK_LIBRARY_EXISTS(gd gdImagePng "." HAVE_GD_LIB)
       TARGET_LINK_LIBRARIES(sarg ${GD_LIBRARY})
-      SET(HAVE_GD GD_LIBRARY CACHE PATH DOC "True IF GD was found")
-      SET(HAVE_GD CACHE BOOL DOC "True IF must use GD")
+      SET(HAVE_GD_LIB GD_LIBRARY CACHE PATH DOC "True IF GD was found")
+      SET(HAVE_GD_LIB CACHE BOOL DOC "True IF must use GD")
    ENDIF(GD_LIBRARY)
 ENDIF(HAVE_GD_H)
 
@@ -137,27 +177,54 @@
       ENDIF(ICONV_LIBRARY)
       CHECK_FUNCTION_EXISTS(iconv_open HAVE_ICONV)
 
-      SET(ICONV_CONST_FILE ${CMAKE_BINARY_DIR}/consticonv.c)
-      FILE(WRITE ${ICONV_CONST_FILE} "
-#include <stdlib.h>
+      IF(NOT USE_CONST_ICONV)
+         SET(ICONV_CONST_FILE ${CMAKE_BINARY_DIR}/consticonv.c)
+         FILE(WRITE ${ICONV_CONST_FILE} "
 #include <iconv.h>
-extern
-#ifdef __cplusplus
-"C"
+#ifdef __CLASSIC_C__
+int main(){
+  int ac;
+  char*av[];
+#else
+int main(int ac, char*av[]){
 #endif
-#if defined(__STDC__) || defined(__cplusplus)
-size_t iconv (iconv_t cd, char * *inbuf, size_t *inbytesleft, char * *outbuf, size_t *outbytesleft);
-#else
-size_t iconv();
-#endif
+  iconv_t localtoutf=(iconv_t)-1;
+  const char *str=\"\";
+  char *sstr=\"\";
+  size_t slen=0, sslen=0;
+
+  iconv (localtoutf, (const char **)&str, &slen, &sstr, &sslen);
+  if(ac > 1000)
+    {
+    return *av[0];
+    }
+  return 0;
+}
 ")
-      TRY_COMPILE(USE_CONST_ICONV ${CMAKE_BINARY_DIR} ${ICONV_CONST_FILE})
-      FILE(REMOVE ${ICONV_CONST_FILE})
-      IF(USE_CONST_ICONV)
-         SET(ICONV_CONST "\"const\"")
-      ENDIF(USE_CONST_ICONV)
+         TRY_COMPILE(USE_CONST_ICONV ${CMAKE_BINARY_DIR} ${ICONV_CONST_FILE} CMAKE_FLAGS -DLINK_LIBRARIES="iconv")
+         FILE(REMOVE ${ICONV_CONST_FILE})
+         IF(USE_CONST_ICONV)
+            SET(ICONV_CONST "const" CACHE STRING "The type of char to use with iconv")
+            MESSAGE(STATUS "iconv requires const char **")
+         ELSEIF(USE_CONST_ICONV)
+            SET(ICONV_CONST "" CACHE STRING "The type of char to use with iconv")
+            MESSAGE(STATUS "iconv requires char **")
+         ENDIF(USE_CONST_ICONV)
+         SET(USE_CONST_ICONV TRUE CACHE BOOL "Use const char ** with iconv")
+      ENDIF(NOT USE_CONST_ICONV)
    ENDIF(HAVE_ICONV_H)
 ENDIF(ENABLE_ICONV)
+
+# Find ldap
+CHECK_INCLUDE_FILE(ldap.h HAVE_LDAP_H)
+IF(HAVE_LDAP_H)
+   FIND_LIBRARY(LDAP_LIBRARY NAMES ldap DOC "The ldap library")
+   IF(LDAP_LIBRARY)
+      TARGET_LINK_LIBRARIES(sarg ${LDAP_LIBRARY})
+      SET(HAVE_LDAP LDAP_LIBRARY CACHE PATH DOC "True if LDAP was found")
+      SET(HAVE_LDAP CACHE BOOL DOC "True if must use LDAP")
+   ENDIF(LDAP_LIBRARY)
+ENDIF(HAVE_LDAP_H)
 
 # Support for large files
 OPTION(ENABLE_LARGEFILE "Enable the usage of large files" ON)
@@ -222,22 +289,9 @@
    ELSE(RLIM_T STREQUAL 4)
       MESSAGE("Unknown rlim_t size")
    ENDIF(RLIM_T STREQUAL 4)
-ELSE(HAVE_RLIM_T)
-   MESSAGE("Cannot detect the size of your system's rlim_t type")
+#ELSE(HAVE_RLIM_T)
+#   MESSAGE("Cannot detect the size of your system's rlim_t type")
 ENDIF(HAVE_RLIM_T)
-
-# Windows need lib wsock32
-IF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
-   CHECK_INCLUDE_FILE(windows.h HAVE_WINDOWS_H)
-   CHECK_INCLUDE_FILE(winsock.h HAVE_WINSOCK_H)
-   FIND_LIBRARY(WSOCK_LIB NAMES wsock32 DOC "The winsock library")
-   #check_library_exists(wsock32 "." HAVE_WSOCK)
-   IF(WSOCK_LIB)
-      #set_target_properties(sarg PROPERTIES LINK_FLAGS "${LINK_FLAGS} -lwsock32")
-      TARGET_LINK_LIBRARIES(sarg wsock32)
-   ENDIF(WSOCK_LIB)
-   ADD_DEFINITIONS(-DWINDOWS)
-ENDIF(CMAKE_SYSTEM_NAME STREQUAL "Windows")
 
 CHECK_FUNCTION_EXISTS(mkstemp HAVE_MKSTEMP)
 IF(NOT HAVE_MKSTEMP)
@@ -248,43 +302,14 @@
    ENDIF(IBERTY_LIB)
 ENDIF(NOT HAVE_MKSTEMP)
 
-# System particularities
-IF(CMAKE_SYSTEM_NAME STREQUAL "solaris")
-   TARGET_LINK_LIBRARIES(sarg socket nsl)
-   #SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_DEFINITIONS="-DSOLARIS ${COMPILE_DEFINITIONS}")
-   ADD_DEFINITIONS(-DSOLARIS)
-ENDIF(CMAKE_SYSTEM_NAME STREQUAL "solaris")
-
-OPTION(ENABLE_EXTRA_PROTECT "Enable compile and runtime extra protections" OFF)
-IF(ENABLE_EXTRA_PROTECT)
-   GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
-   SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -fstack-protector -D_FORTIFY_SOURCE=2 -Werror")
-   CHECK_C_COMPILER_FLAG("-Wformat -Werror=format-security" HAVE_WERROR_FORMAT_SECURITY)
-   IF(HAVE_WERROR_FORMAT_SECURITY)
-      GET_TARGET_PROPERTY(TMPCFLAGS sarg COMPILE_FLAGS)
-      SET_TARGET_PROPERTIES(sarg PROPERTIES COMPILE_FLAGS "${TMPCFLAGS} -Wformat -Werror=format-security")
-   ENDIF(HAVE_WERROR_FORMAT_SECURITY)
-ENDIF(ENABLE_EXTRA_PROTECT)
-
-# Save the configuration for the project
-CONFIGURE_FILE("${CMAKE_SOURCE_DIR}/include/config.h.in" "${CMAKE_BINARY_DIR}/config.h" @ONLY)
-
-# Installation of the project
-INSTALL(TARGETS sarg DESTINATION "${BINDIR}")
-INSTALL(FILES sarg.conf DESTINATION "${SYSCONFDIR}" RENAME sarg.conf.exemple)
-INSTALL(FILES exclude_codes user_limit_block css.tpl DESTINATION "${SYSCONFDIR}")
-INSTALL(FILES sarg.1 DESTINATION "${MANDIR}")
-INSTALL(DIRECTORY languages/ DESTINATION "${LANGDIR}" PATTERN ".svn" EXCLUDE)
-INSTALL(DIRECTORY images/ DESTINATION "${IMAGEDIR}" PATTERN ".svn" EXCLUDE)
-INSTALL(DIRECTORY fonts/ DESTINATION "${FONTDIR}" FILES_MATCHING PATTERN "*.ttf" PATTERN ".svn" EXCLUDE)
-INSTALL(DIRECTORY sarg-php/ DESTINATION "${SARGPHPDIR}" PATTERN ".svn" EXCLUDE)
-
-# Package creation
-SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Squid Analysis Report Generator")
-SET(CPACK_PACKAGE_VERSION_MAJOR "${sarg_VERSION}")
-SET(CPACK_PACKAGE_VERSION_MINOR "${sarg_REVISION}")
-SET(CPACK_PACKAGE_VERSION_PATCH "${sarg_BUILD}")
-SET(CPACK_GENERATOR TGZ)
-SET(CPACK_SOURCE_GENERATOR TGZ)
-SET(CPACK_SOURCE_IGNORE_FILES "/.svn/" "/debian/" "/html/" "Makefile$" "config\\\\.log$" "config\\\\.status$" ".*~$" "\\\\.o$")
-INCLUDE(CPack)
+# Gettext and friends
+IF(NOT HAVE_LC_MESSAGES)
+   SET(FILES)
+   IF(HAVE_LOCALE_H)
+      LIST(APPEND FILES "locale.h")
+   ENDIF(HAVE_LOCALE_H)
+   IF(HAVE_LIBINTL_H)
+      LIST(APPEND FILES "libintl.h")
+   ENDIF(HAVE_LIBINTL_H)
+   LIST(LENGTH FILES NFILES)
+   IF(NFILES GREATER 0)

## sarg 2.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
-SET(sarg_REVISION "3")
+SET(sarg_REVISION "3.1")
 SET(sarg_BUILD "")
-SET(sarg_BUILDDATE "Jun-21-2010")
+SET(sarg_BUILDDATE "Sep-18-2010")
 
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)

## sarg 2.3.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
-SET(sarg_REVISION "3.1")
+SET(sarg_REVISION "3.2")
 SET(sarg_BUILD "")
-SET(sarg_BUILDDATE "Sep-18-2010")
+SET(sarg_BUILDDATE "Nov-23-2011")
 
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)
@@ -12,6 +12,7 @@
 INCLUDE(CheckTypeSize)
 INCLUDE(CheckSymbolExists)
 INCLUDE(CheckCCompilerFlag)
+INCLUDE(CheckStructHasMember)
 
 DEFINE_PROPERTY(GLOBAL PROPERTY enable-htmldir BRIEF_DOCS "--enable-htmldir=htmldir"
                         FULL_DOCS "Select htmldir as the root of your WWW documents")
@@ -37,7 +38,7 @@
 
 SET(SYSCONFDIR "etc/sarg" CACHE PATH "The configuration directory relative to the install directory")
 SET(BINDIR "bin" CACHE PATH "The directory to install the exec relative to the install directory")
-SET(MANDIR "share/man" CACHE PATH "The directory to copy the man page relative to the install directory")
+SET(MANDIR "share/man/man1" CACHE PATH "The directory to copy the man page relative to the install directory")
 SET(LANGDIR "share/sarg/languages" CACHE PATH "The directory to copy the languages files relative to the install directory")
 SET(FONTDIR "share/sarg/fonts" CACHE PATH "The directory to copy the fonts relative to the install directory")
 SET(IMAGEDIR "share/sarg/images" CACHE PATH "The directory to copy the images files relative to the install directory")
@@ -47,13 +48,13 @@
 INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}") #Make it find this config.h before the one in src/include
 INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/include")
 SET(SRC util.c log.c report.c topuser.c email.c sort.c html.c
-       totger.c index.c getconf.c usage.c decomp.c ip2name.c
+       index.c getconf.c usage.c decomp.c ip2name.c
        useragent.c exclude.c convlog.c totday.c repday.c datafile.c
        indexonly.c splitlog.c lastlog.c topsites.c siteuser.c css.c
        smartfilter.c denied.c authfail.c charset.c
-       squidguard_log.c squidguard_report.c auth.c download.c grepday.c
+       redirector.c auth.c download.c grepday.c
        dansguardian_log.c dansguardian_report.c realtime.c btree_cache.c
-       usertab.c userinfo.c longline.c)
+       usertab.c userinfo.c longline.c url.c)
 
 FOREACH(f ${SRC})
    ADD_FILE_DEPENDENCIES(${f} ${CMAKE_BINARY_DIR}/config.h ${CMAKE_SOURCE_DIR}/include/conf.h ${CMAKE_SOURCE_DIR}/include/info.h ${CMAKE_SOURCE_DIR}/include/defs.h)
@@ -95,10 +96,10 @@
 CHECK_INCLUDE_FILE(unistd.h HAVE_UNISTD_H)
 CHECK_INCLUDE_FILE(sys/dirent.h HAVE_SYS_DIRENT_H)
 CHECK_INCLUDE_FILE(dirent.h HAVE_DIRENT_H)
+CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
 CHECK_INCLUDE_FILE(sys/socket.h HAVE_SYS_SOCKET_H)
 CHECK_INCLUDE_FILE(netdb.h HAVE_NETDB_H)
 CHECK_INCLUDE_FILE(arpa/inet.h HAVE_ARPA_INET_H)
-CHECK_INCLUDE_FILE(sys/types.h HAVE_SYS_TYPES_H)
 CHECK_INCLUDE_FILE(netinet/in.h HAVE_NETINET_H)
 CHECK_INCLUDE_FILE(sys/stat.h HAVE_SYS_STAT_H)
 CHECK_INCLUDE_FILE(ctype.h HAVE_CTYPE_H)
@@ -115,6 +116,7 @@
 CHECK_INCLUDE_FILE(libgen.h HAVE_LIBGEN_H)
 CHECK_INCLUDE_FILE(stdbool.h HAVE_STDBOOL_H)
 CHECK_INCLUDE_FILE(getopt.h HAVE_GETOPT_H)
+CHECK_INCLUDE_FILE(fcntl.h HAVE_FCNTL_H)
 
 IF(!HAVE_GETOPT_H)
    MESSAGE(SEND_ERROR "getopt.h is required to compile sarg")
@@ -146,7 +148,10 @@
 CHECK_FUNCTION_EXISTS(symlink HAVE_SYMLINK)
 CHECK_FUNCTION_EXISTS(lstat HAVE_LSTAT)
 CHECK_FUNCTION_EXISTS(getnameinfo HAVE_GETNAMEINFO)
+CHECK_FUNCTION_EXISTS(getaddrinfo HAVE_GETADDRINFO)
 CHECK_FUNCTION_EXISTS(inet_aton HAVE_INET_ATON)
+
+CHECK_STRUCT_HAS_MEMBER("struct sockaddr_storage" ss_len sys/socket.h HAVE_SOCKADDR_SA_LEN)
 
 # Find gd
 CHECK_INCLUDE_FILE(gd.h HAVE_GD_H)
@@ -307,9 +312,3 @@
    SET(FILES)
    IF(HAVE_LOCALE_H)
       LIST(APPEND FILES "locale.h")
-   ENDIF(HAVE_LOCALE_H)
-   IF(HAVE_LIBINTL_H)
-      LIST(APPEND FILES "libintl.h")
-   ENDIF(HAVE_LIBINTL_H)
-   LIST(LENGTH FILES NFILES)
-   IF(NFILES GREATER 0)

=== debian/changelog ===
sarg (2.3.2-2) unstable; urgency=low

  * debian/rules
    - Fixed wrong auto detection of build system by dh (Closes: #654319)

 -- Luigi Gangitano <luigi@debian.org>  Fri, 06 Jan 2012 01:32:52 +0100

sarg (2.3.2-1) unstable; urgency=low

  * New upstream release
    - Fixes FTBFS with latest GCC (Closes: #626228)

  * debian/{control,rules,install,manpages,source/format,patches/*}
    - Switch to source format 3.0 (quilt)

  * debian/control
    - Bumped Standard-Version to 3.9.2 (no change needed)

 -- Luigi Gangitano <luigi@debian.org>  Mon, 26 Dec 2011 18:21:40 +0100

sarg (2.3.1-2) unstable; urgency=low

  * debian/{patches/03_build-with-gcc44,rules}
    - Removed configure.in patch, replaced with LDFLAG in debian/rules,
      thanks to Andrea Gasparini

 -- Luigi Gangitano <luigi@debian.org>  Sat, 19 Feb 2011 17:48:24 +0100

sarg (2.3.1-1) unstable; urgency=low

  * New upstream release

  * debian/sarg-reports
    - Fix date interval for daily/weekly/monthly (Closes: #592705)

  * debian/preinst
    - Remove old language files (Closes: #606778)
    - Fix moving output files on upgrade

  * debian/patches/03_build-with-gcc44
    - Added libm check to configure.in to comply with gcc-4.4 linker chages

  * debian/control
    - Bumped Standard-Version to 3.9.1 (no change needed)

 -- Luigi Gangitano <luigi@debian.org>  Fri, 18 Feb 2011 19:59:33 +0100

sarg (2.3-1) unstable; urgency=low

  * New upstream release

  * debian/rules
    - Removed references to now non existent language dir

  * debian/control
    - Added build dependency on libldap2-dev
    - Bumped Standard-Version to 3.8.4 (no change needed)

  * debian/sarg.conf
    - Updated to match new upstream config file

  * debian/preinst
    - Fix moving old data files

 -- Luigi Gangitano <luigi@debian.org>  Sat, 26 Jun 2010 00:49:09 +0200

sarg (2.2.7.1-2) unstable; urgency=low

  * debian/{preinst,postinst}
    - Move configuration files preserving user changes (Closes: #566402)
    - Do not move duplicate fonts
    - Remove fonts marked as configuration files

 -- Luigi Gangitano <luigi@debian.org>  Sun, 28 Mar 2010 01:33:48 +0100

sarg (2.2.7.1-1) unstable; urgency=low

  * New upstream release

  * debian/sarg.conf
    - Updated default configuration file to match upstream changes.
    - Removed invalid config directive (Closes: #568009)

  * debian/README.source
    - Added simple dpatch-referring REAMDE.source

  * debian/{rules,control}
    - Remove duplicate font files and depend on ttf-dejavu-core | ttf-freefont
      (Closes: #567329)

 -- Luigi Gangitano <luigi@debian.org>  Tue, 16 Feb 2010 11:07:18 +0100

sarg (2.2.7-1) UNRELEASED; urgency=low

  * New upstream release
    - Fixes sarg.hosts exclusion for subdomains (Closes: #408577)

  * debian/patches/01_makefile-install-path
    - Removed patch integrated upstream

  * debian/rules
    - Use --enable-sargphp instead of --enable-htmldir

 -- Luigi Gangitano <luigi@debian.org>  Mon, 08 Feb 2010 08:00:10 +0100

sarg (2.2.6-1) unstable; urgency=low

  * New upstream release
    - Fixes issues in getword loop detection (Closes: #522284)
    - Removed patches integrated upstream
    - Fixes usertab parsing for IPv6 address (Closes: #504749)
    - Fixes typo in dansguardian_log.c (Closes: #540438)
    - Fixes error parsing squidGuard logs (Closes: #486895)

  * debian/sarg-reports.conf
    - Fixed typo (Closes: #517356)

  * debian/control
    - Added Build-Dep options on libgd2-xpm-dev (Closes: #540121)
    - Added Dependency on ${misc:Depends}
    - Added dependency on dpatch
    - Bumped Standard-Version to 3.8.3

  * debian/compat
    - Upgraded debhelper compatibility to level 6

  * debian/rules
    - Removed unnecessary upgrade of autoconf files
    - Added dpatch rules
    - Fixed configuration options and paths

  * debian/patches/01_makefile-install-path
    - Fixed build-time installation paths

  * debian/patches/02_config-file-references
    - Fixed references to configuration files

  * debian/squid.conf
    - Sinced with upstream changes

  * debian/{postrm,preinst,sarg.conf,sarg-reports,rules,dirs,sarg-reports.conf}
    - Moved configuration files to /etc/sarg and data directory to /var/lib/sarg
      (Closes: #553554, #502273)

 -- Luigi Gangitano <luigi@debian.org>  Mon, 11 Jan 2010 15:07:10 +0100

sarg (2.2.5-2) unstable; urgency=low

  * debian/watch
    - Use SF redirector and make lintian happy

  * debian/{rules,compat}
    - Move DH_COMPAT to debian/compat and make lintian happy

  * debian/rules
    - Change make clean invocation and make lintian happier
    - Added support for DEB_BUILD_OPTIONS
    - Move documentation files from sarg-php to doc directory
    - Remove hidden file from /etc/squid/languages

  * debian/control
    - Removed dependency on bash, now essential
    - Bumped Standard-Version to 3.8.0

  * debian/postinst
    - Make postint fail on error

  * debian/copyright
    - Added copyright notice
    - Updated maintainer reference

  * debian/sarg-reports.1
    - Added man page, thanks to Juan Angulo Moreno (Closes: #481889)

  * debian/patches/show_read_statistics.patch
    - Added patch from Vladimir Lettiev fixing segfault with
      show_read_statistics set to no. (Closes: #444845, # 370811)

  * debian/patches/totger_patches.patch
    - Added patch from Thomas Bliesener fixing several buffer overflows
      (Closes: #470791)

  * debian/patches/opensuse_1_getword_boundary_limit.patch
    - Added patch from OpenSUSE to avoid segfaults in getword() calls

  * debian/patches/opensuse_2_enlarge_report_buffers.patch
    - Added patch from OpenSUSE to avoid overflow in report buffers

  * debian/patches/opensuse_3_too_small_font_buffer.patch
    - Added patch from OpenSUSE to avoid overflow in font buffer

  * debian/patches/opensuse_4_enlarge_log_buffer.patch
    - Added patch from OpenSUSE to avoid overflow in log buffer

  * debian/patches/opensuse_5_limit_sprintf.patch


=== debian/control ===
Source: sarg
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, libgd2-noxpm-dev | libgd2-xpm-dev, libldap2-dev
Section: web
Priority: optional
Maintainer: Luigi Gangitano <luigi@debian.org>
Standards-Version: 3.9.2

Package: sarg
Architecture: any
Replaces: sqmgrlog
Depends: ${shlibs:Depends}, ${misc:Depends}, ttf-dejavu-core | ttf-freefont
Suggests: squid, httpd | apache2, squidguard, libapache2-mod-php5
Conflicts: sqmgrlog
Description: squid analysis report generator
 Sarg is a Squid Analysis Report Generator that allow you to view "where" 
 your users are going to on the Internet. Sarg generate reports in html, 
 with many fields, like: users, IP Addresses, bytes, sites and times.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

INSTALL = install
INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
INSTALL_PROGRAM = $(INSTALL) -p    -o root -g root  -m  755
INSTALL_SCRIPT  = $(INSTALL) -p    -o root -g root  -m  755
INSTALL_DIR     = $(INSTALL) -p -d -o root -g root  -m  755

%:
	dh  $@

override_dh_auto_configure:
	chmod 755 configure
	dh_auto_configure -Sautoconf -- --prefix=/usr \
		--mandir=\$${prefix}/share/man \
		--infodir=\$${prefix}/share/info \
		--bindir=/usr/bin \
		--sysconfdir=/etc/sarg \
		--mandir=/usr/share/man/man1 \
		--enable-fontdir=/usr/share/fonts/truetype/ttf-dejavu \
		--enable-imagedir=/usr/share/sarg/images \
		--enable-sargphp=/usr/share/sarg



override_dh_auto_install:
	dh_auto_install
	$(INSTALL_FILE) debian/sarg.conf debian/sarg/etc/sarg
	$(INSTALL_FILE) debian/sarg.hosts debian/sarg/etc/sarg/exclude_hosts
	$(INSTALL_FILE) debian/sarg.users debian/sarg/etc/sarg/exclude_users
	$(INSTALL_FILE) debian/sarg.usertab debian/sarg/etc/sarg/usertab
	rm -r debian/sarg/usr/share/fonts
	$(INSTALL_SCRIPT) debian/sarg-reports debian/sarg/usr/sbin/sarg-reports
	$(INSTALL_FILE) debian/sarg-reports.conf debian/sarg/etc/sarg
	$(INSTALL_SCRIPT) debian/sarg-reports.cron.daily debian/sarg/etc/cron.daily/sarg
	$(INSTALL_SCRIPT) debian/sarg-reports.cron.weekly debian/sarg/etc/cron.weekly/sarg
	$(INSTALL_SCRIPT) debian/sarg-reports.cron.monthly debian/sarg/etc/cron.monthly/sarg
	$(INSTALL_FILE) css.tpl debian/sarg/usr/share/doc/sarg
	rm debian/sarg/usr/share/sarg/sarg-php/COPYING
	mv debian/sarg/usr/share/sarg/sarg-php/INSTALL debian/sarg/usr/share/doc/sarg/README.sarg.php
	mv debian/sarg/usr/share/sarg/sarg-php/LANGUAGES debian/sarg/usr/share/doc/sarg/LANGUAGES.sarg.php
	chmod 644 debian/sarg/etc/sarg/sarg.*
	chmod 755 debian/sarg/etc/sarg
	chmod 755 debian/sarg/usr/sbin/sarg-reports
	chmod 755 debian/sarg/etc/cron.daily/sarg
	chmod 755 debian/sarg/etc/cron.weekly/sarg
	chmod 755 debian/sarg/etc/cron.monthly/sarg

## sarg 2.3.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,9 @@
 CMAKE_MINIMUM_REQUIRED (VERSION 2.6)
 PROJECT(sarg C)
 SET(sarg_VERSION 2)
-SET(sarg_REVISION "3.2")
+SET(sarg_REVISION "3.6")
 SET(sarg_BUILD "")
-SET(sarg_BUILDDATE "Nov-23-2011")
-
+SET(sarg_BUILDDATE "Apr-21-2013")
 INCLUDE(AddFileDependencies)
 INCLUDE(CheckIncludeFile)
 INCLUDE(CheckLibraryExists)
@@ -32,14 +31,12 @@
 ENDMACRO(SET_ABS_SOURCE VAR DOC)
 
 SET_ABS_SOURCE(SYSCONFDIR "The full path of the configuration directory to be compiled in the program")
-SET_ABS_SOURCE(LANGDIR "The full path of the language directory to be compiled in the program")
 SET_ABS_SOURCE(FONTDIR "The full path of the fonts directory to be compiled in the program")
 SET_ABS_SOURCE(IMAGEDIR "The full path of the images directory to be compiled in the program")
 
 SET(SYSCONFDIR "etc/sarg" CACHE PATH "The configuration directory relative to the install directory")
 SET(BINDIR "bin" CACHE PATH "The directory to install the exec relative to the install directory")
 SET(MANDIR "share/man/man1" CACHE PATH "The directory to copy the man page relative to the install directory")
-SET(LANGDIR "share/sarg/languages" CACHE PATH "The directory to copy the languages files relative to the install directory")
 SET(FONTDIR "share/sarg/fonts" CACHE PATH "The directory to copy the fonts relative to the install directory")
 SET(IMAGEDIR "share/sarg/images" CACHE PATH "The directory to copy the images files relative to the install directory")
 SET(SARGPHPDIR "share/sarg/sarg-php" CACHE PATH "The directory to copy sarg-php relative to the install directory")
@@ -48,11 +45,11 @@
 INCLUDE_DIRECTORIES("${CMAKE_BINARY_DIR}") #Make it find this config.h before the one in src/include
 INCLUDE_DIRECTORIES("${CMAKE_SOURCE_DIR}/include")
 SET(SRC util.c log.c report.c topuser.c email.c sort.c html.c
-       index.c getconf.c usage.c decomp.c ip2name.c
+       index.c getconf.c usage.c decomp.c ip2name.c ip2name_dns.c
        useragent.c exclude.c convlog.c totday.c repday.c datafile.c
        indexonly.c splitlog.c lastlog.c topsites.c siteuser.c css.c
-       smartfilter.c denied.c authfail.c charset.c
-       redirector.c auth.c download.c grepday.c
+       smartfilter.c denied.c authfail.c charset.c dichotomic.c
+       redirector.c auth.c download.c grepday.c ip2name_exec.c
        dansguardian_log.c dansguardian_report.c realtime.c btree_cache.c
        usertab.c userinfo.c longline.c url.c)
 
@@ -230,6 +227,17 @@
       SET(HAVE_LDAP CACHE BOOL DOC "True if must use LDAP")
    ENDIF(LDAP_LIBRARY)
 ENDIF(HAVE_LDAP_H)
+
+# Find pcre
+CHECK_INCLUDE_FILE(pcre.h HAVE_PCRE_H)
+IF(HAVE_PCRE_H)
+   FIND_LIBRARY(PCRE_LIBRARY NAMES pcre DOC "The pcre library")
+   IF(PCRE_LIBRARY)
+      TARGET_LINK_LIBRARIES(sarg ${PCRE_LIBRARY})
+      SET(HAVE_PCRE PCRE_LIBRARY CACHE PATH DOC "True if pcre was found")
+      SET(HAVE_PCRE CACHE BOOL DOC "True if must use pcre")
+   ENDIF(PCRE_LIBRARY)
+ENDIF(HAVE_PCRE_H)
 
 # Support for large files
 OPTION(ENABLE_LARGEFILE "Enable the usage of large files" ON)
@@ -303,12 +311,3 @@
    # MingW provide mkstemps in libiberty but doesn't declare it in any header file
    FIND_LIBRARY(IBERTY_LIB NAMES iberty DOC "The library of mingw containing mkstemps")
    IF(IBERTY_LIB)
-      TARGET_LINK_LIBRARIES(sarg iberty)
-   ENDIF(IBERTY_LIB)
-ENDIF(NOT HAVE_MKSTEMP)
-
-# Gettext and friends
-IF(NOT HAVE_LC_MESSAGES)
-   SET(FILES)
-   IF(HAVE_LOCALE_H)
-      LIST(APPEND FILES "locale.h")

=== debian/changelog ===
sarg (2.3.6-1build1) saucy; urgency=low

  * Rebuild for libgd3.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 20 May 2013 00:32:41 +0100

sarg (2.3.6-1) unstable; urgency=low

  * New upstream release

  * debian/{compat,control,rules}
    - Move the debhelper 9 compatibility and enable hardening flags

  * debian/control
    - Added dependency on dpkg-dev (>= 1.16.1~)
    - Bumped Standard-Version to 3.9.4 (no change needed)

  * debian/rules
    - Add executable bit to /etc/sarg/user_limit_block

  * debian/sarg-reports.1
    - Fixed configuration file reference (Closes: #674036)

 -- Luigi Gangitano <luigi@debian.org>  Mon, 06 May 2013 16:39:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: sarg
-Build-Depends: debhelper (>= 7.0.50~), autotools-dev, libgd2-noxpm-dev | libgd2-xpm-dev, libldap2-dev
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), autotools-dev, libgd2-noxpm-dev | libgd2-xpm-dev, libldap2-dev
 Section: web
 Priority: optional
 Maintainer: Luigi Gangitano <luigi@debian.org>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 
 Package: sarg
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,10 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 #export DH_OPTIONS=-v
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 INSTALL = install
 INSTALL_FILE    = $(INSTALL) -p    -o root -g root  -m  644
@@ -44,6 +48,7 @@
 	mv debian/sarg/usr/share/sarg/sarg-php/LANGUAGES debian/sarg/usr/share/doc/sarg/LANGUAGES.sarg.php
 	chmod 644 debian/sarg/etc/sarg/sarg.*
 	chmod 755 debian/sarg/etc/sarg
+	chmod 755 debian/sarg/etc/sarg/user_limit_block
 	chmod 755 debian/sarg/usr/sbin/sarg-reports
 	chmod 755 debian/sarg/etc/cron.daily/sarg
 	chmod 755 debian/sarg/etc/cron.weekly/sarg

=== debian/watch ===
version=2
http://sf.net/sarg/sarg-(.*)\.tar\.gz debian uupdate
